// SPDX-License-Identifier: MIT
// Copyright (C) 2018-present iced project and contributors

// ⚠️This file was generated by GENERATOR!🦹‍♂️

package com.github.icedland.iced.x86;

/**
 * Instruction operand kind
 */
public final class OpKind {
	private OpKind() {
	}

	/**
	 * A register ({@link com.github.icedland.iced.x86.Register}).<!-- --><p>
	 * This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getOp0Register()}, {@link com.github.icedland.iced.x86.Instruction#getOp1Register()}, {@link com.github.icedland.iced.x86.Instruction#getOp2Register()}, {@link com.github.icedland.iced.x86.Instruction#getOp3Register()} or {@link com.github.icedland.iced.x86.Instruction#getOp4Register()} depending on operand number.<!-- --> See also {@link com.github.icedland.iced.x86.Instruction#getOpRegister(int)}.<!-- -->
	 */
	public static final int REGISTER = 0;
	/**
	 * Near 16-bit branch.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getNearBranch16()}
	 */
	public static final int NEAR_BRANCH16 = 1;
	/**
	 * Near 32-bit branch.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getNearBranch32()}
	 */
	public static final int NEAR_BRANCH32 = 2;
	/**
	 * Near 64-bit branch.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getNearBranch64()}
	 */
	public static final int NEAR_BRANCH64 = 3;
	/**
	 * Far 16-bit branch.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getFarBranch16()} and {@link com.github.icedland.iced.x86.Instruction#getFarBranchSelector()}
	 */
	public static final int FAR_BRANCH16 = 4;
	/**
	 * Far 32-bit branch.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getFarBranch32()} and {@link com.github.icedland.iced.x86.Instruction#getFarBranchSelector()}
	 */
	public static final int FAR_BRANCH32 = 5;
	/**
	 * 8-bit constant.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getImmediate8()}
	 */
	public static final int IMMEDIATE8 = 6;
	/**
	 * 8-bit constant used by the {@code ENTER}, {@code EXTRQ}, {@code INSERTQ} instructions.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getImmediate8_2nd()}
	 */
	public static final int IMMEDIATE8_2ND = 7;
	/**
	 * 16-bit constant.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getImmediate16()}
	 */
	public static final int IMMEDIATE16 = 8;
	/**
	 * 32-bit constant.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getImmediate32()}
	 */
	public static final int IMMEDIATE32 = 9;
	/**
	 * 64-bit constant.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getImmediate64()}
	 */
	public static final int IMMEDIATE64 = 10;
	/**
	 * An 8-bit value sign extended to 16 bits.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getImmediate8to16()}
	 */
	public static final int IMMEDIATE8TO16 = 11;
	/**
	 * An 8-bit value sign extended to 32 bits.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getImmediate8to32()}
	 */
	public static final int IMMEDIATE8TO32 = 12;
	/**
	 * An 8-bit value sign extended to 64 bits.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getImmediate8to64()}
	 */
	public static final int IMMEDIATE8TO64 = 13;
	/**
	 * A 32-bit value sign extended to 64 bits.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getImmediate32to64()}
	 */
	public static final int IMMEDIATE32TO64 = 14;
	/**
	 * {@code seg:[SI]}.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getMemorySize()}, {@link com.github.icedland.iced.x86.Instruction#getMemorySegment()}, {@link com.github.icedland.iced.x86.Instruction#getSegmentPrefix()}
	 */
	public static final int MEMORY_SEG_SI = 15;
	/**
	 * {@code seg:[ESI]}.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getMemorySize()}, {@link com.github.icedland.iced.x86.Instruction#getMemorySegment()}, {@link com.github.icedland.iced.x86.Instruction#getSegmentPrefix()}
	 */
	public static final int MEMORY_SEG_ESI = 16;
	/**
	 * {@code seg:[RSI]}.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getMemorySize()}, {@link com.github.icedland.iced.x86.Instruction#getMemorySegment()}, {@link com.github.icedland.iced.x86.Instruction#getSegmentPrefix()}
	 */
	public static final int MEMORY_SEG_RSI = 17;
	/**
	 * {@code seg:[DI]}.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getMemorySize()}, {@link com.github.icedland.iced.x86.Instruction#getMemorySegment()}, {@link com.github.icedland.iced.x86.Instruction#getSegmentPrefix()}
	 */
	public static final int MEMORY_SEG_DI = 18;
	/**
	 * {@code seg:[EDI]}.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getMemorySize()}, {@link com.github.icedland.iced.x86.Instruction#getMemorySegment()}, {@link com.github.icedland.iced.x86.Instruction#getSegmentPrefix()}
	 */
	public static final int MEMORY_SEG_EDI = 19;
	/**
	 * {@code seg:[RDI]}.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getMemorySize()}, {@link com.github.icedland.iced.x86.Instruction#getMemorySegment()}, {@link com.github.icedland.iced.x86.Instruction#getSegmentPrefix()}
	 */
	public static final int MEMORY_SEG_RDI = 20;
	/**
	 * {@code ES:[DI]}.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getMemorySize()}
	 */
	public static final int MEMORY_ESDI = 21;
	/**
	 * {@code ES:[EDI]}.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getMemorySize()}
	 */
	public static final int MEMORY_ESEDI = 22;
	/**
	 * {@code ES:[RDI]}.<!-- --> This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getMemorySize()}
	 */
	public static final int MEMORY_ESRDI = 23;
	/**
	 * Memory operand.<!-- --><p>
	 * This operand kind uses {@link com.github.icedland.iced.x86.Instruction#getMemoryDisplSize()}, {@link com.github.icedland.iced.x86.Instruction#getMemorySize()}, {@link com.github.icedland.iced.x86.Instruction#getMemoryIndexScale()}, {@link com.github.icedland.iced.x86.Instruction#getMemoryDisplacement64()}, {@link com.github.icedland.iced.x86.Instruction#getMemoryBase()}, {@link com.github.icedland.iced.x86.Instruction#getMemoryIndex()}, {@link com.github.icedland.iced.x86.Instruction#getMemorySegment()}, {@link com.github.icedland.iced.x86.Instruction#getSegmentPrefix()}
	 */
	public static final int MEMORY = 24;
}
