// SPDX-License-Identifier: MIT
// Copyright (C) 2018-present iced project and contributors

// ⚠️This file was generated by GENERATOR!🦹‍♂️

package com.github.icedland.iced.x86.asm;

/**
 * Registers passed to {@link CodeAssembler} methods
 *
 * @see AsmRegisters
 * @see AsmRegistersVec
 * @see AsmRegistersGPR8
 * @see AsmRegistersGPR16
 * @see AsmRegistersGPR32
 * @see AsmRegistersGPR64
 * @see AsmRegistersIP
 * @see AsmRegistersSegment
 * @see AsmRegistersST
 * @see AsmRegistersCR
 * @see AsmRegistersDR
 * @see AsmRegistersTR
 * @see AsmRegistersBND
 * @see AsmRegistersK
 * @see AsmRegistersMM
 * @see AsmRegistersXMM
 * @see AsmRegistersYMM
 * @see AsmRegistersZMM
 * @see AsmRegistersTMM
 */
public final class AsmRegistersGPR {
	private AsmRegistersGPR() {
	}

	public static final AsmRegister8 al = AsmRegisters.al;
	public static final AsmRegister8 cl = AsmRegisters.cl;
	public static final AsmRegister8 dl = AsmRegisters.dl;
	public static final AsmRegister8 bl = AsmRegisters.bl;
	public static final AsmRegister8 ah = AsmRegisters.ah;
	public static final AsmRegister8 ch = AsmRegisters.ch;
	public static final AsmRegister8 dh = AsmRegisters.dh;
	public static final AsmRegister8 bh = AsmRegisters.bh;
	public static final AsmRegister8 spl = AsmRegisters.spl;
	public static final AsmRegister8 bpl = AsmRegisters.bpl;
	public static final AsmRegister8 sil = AsmRegisters.sil;
	public static final AsmRegister8 dil = AsmRegisters.dil;
	public static final AsmRegister8 r8b = AsmRegisters.r8b;
	public static final AsmRegister8 r9b = AsmRegisters.r9b;
	public static final AsmRegister8 r10b = AsmRegisters.r10b;
	public static final AsmRegister8 r11b = AsmRegisters.r11b;
	public static final AsmRegister8 r12b = AsmRegisters.r12b;
	public static final AsmRegister8 r13b = AsmRegisters.r13b;
	public static final AsmRegister8 r14b = AsmRegisters.r14b;
	public static final AsmRegister8 r15b = AsmRegisters.r15b;
	public static final AsmRegister16 ax = AsmRegisters.ax;
	public static final AsmRegister16 cx = AsmRegisters.cx;
	public static final AsmRegister16 dx = AsmRegisters.dx;
	public static final AsmRegister16 bx = AsmRegisters.bx;
	public static final AsmRegister16 sp = AsmRegisters.sp;
	public static final AsmRegister16 bp = AsmRegisters.bp;
	public static final AsmRegister16 si = AsmRegisters.si;
	public static final AsmRegister16 di = AsmRegisters.di;
	public static final AsmRegister16 r8w = AsmRegisters.r8w;
	public static final AsmRegister16 r9w = AsmRegisters.r9w;
	public static final AsmRegister16 r10w = AsmRegisters.r10w;
	public static final AsmRegister16 r11w = AsmRegisters.r11w;
	public static final AsmRegister16 r12w = AsmRegisters.r12w;
	public static final AsmRegister16 r13w = AsmRegisters.r13w;
	public static final AsmRegister16 r14w = AsmRegisters.r14w;
	public static final AsmRegister16 r15w = AsmRegisters.r15w;
	public static final AsmRegister32 eax = AsmRegisters.eax;
	public static final AsmRegister32 ecx = AsmRegisters.ecx;
	public static final AsmRegister32 edx = AsmRegisters.edx;
	public static final AsmRegister32 ebx = AsmRegisters.ebx;
	public static final AsmRegister32 esp = AsmRegisters.esp;
	public static final AsmRegister32 ebp = AsmRegisters.ebp;
	public static final AsmRegister32 esi = AsmRegisters.esi;
	public static final AsmRegister32 edi = AsmRegisters.edi;
	public static final AsmRegister32 r8d = AsmRegisters.r8d;
	public static final AsmRegister32 r9d = AsmRegisters.r9d;
	public static final AsmRegister32 r10d = AsmRegisters.r10d;
	public static final AsmRegister32 r11d = AsmRegisters.r11d;
	public static final AsmRegister32 r12d = AsmRegisters.r12d;
	public static final AsmRegister32 r13d = AsmRegisters.r13d;
	public static final AsmRegister32 r14d = AsmRegisters.r14d;
	public static final AsmRegister32 r15d = AsmRegisters.r15d;
	public static final AsmRegister64 rax = AsmRegisters.rax;
	public static final AsmRegister64 rcx = AsmRegisters.rcx;
	public static final AsmRegister64 rdx = AsmRegisters.rdx;
	public static final AsmRegister64 rbx = AsmRegisters.rbx;
	public static final AsmRegister64 rsp = AsmRegisters.rsp;
	public static final AsmRegister64 rbp = AsmRegisters.rbp;
	public static final AsmRegister64 rsi = AsmRegisters.rsi;
	public static final AsmRegister64 rdi = AsmRegisters.rdi;
	public static final AsmRegister64 r8 = AsmRegisters.r8;
	public static final AsmRegister64 r9 = AsmRegisters.r9;
	public static final AsmRegister64 r10 = AsmRegisters.r10;
	public static final AsmRegister64 r11 = AsmRegisters.r11;
	public static final AsmRegister64 r12 = AsmRegisters.r12;
	public static final AsmRegister64 r13 = AsmRegisters.r13;
	public static final AsmRegister64 r14 = AsmRegisters.r14;
	public static final AsmRegister64 r15 = AsmRegisters.r15;
}
